Subject: Re: Routing tables associated with VLANs dissappear when parent ethX down/up

From: Patrick McHardy <[email-masked]>
Date: Wed, 21 Nov 2007 23:24:35 +0100

Ben Greear wrote:
> Patrick McHardy wrote:
>>
>> That comes from iproute itself, but the missing LOWER-UP flag
>> indicates it and that should be enough for bridging and bonding.
>> I'm unsure about this though since its still a big difference in
>> userspace visible behaviour, people might just as well manually
>> configure failover once routing disappears or the device goes down,
>> or just have routing fall through to different routes. All this
>> wouldn't work anymore.
>>
>> Maybe we can make this optional somehow without too much uglyness?
>
> I'm fine with that..we can just add a new vlan-device flag similar to the
> reorder-header flag.

An alternative to this would be something like Julian Anastasov static 
routes
patch. Not sure if it has ever been considered for merging, but its a 
cleaner
way than doing per-device hacks.

http://www.ssi.bg/~ja/

>
> With the current code, on 'UP' of the underlying
> code, all of the VLANs will also go UP, even if the user had previously
> put them DOWN.  That seems like it could be quite dangerous/unexpected
> to me..but I guess it's required if we are going to automatically DOWN 
> them...

Yeah, I too never liked this behaviour.

>
> One other thought:  Maybe we could tell a small lie and say that we have
> NO-CARRIER on the VLAN when the underlying device is down OR has no 
> carrier?
>
> That way we keep normal link up/down semantics w/out having to change the
> admin state of the VLANs...

Thats pretty much what the operstate is doing, it should go to
IF_OPER_LOWERLAYERDOWN when the lower device is down. But as I
said above, people could actually rely on routes disappearing.